#include <bits/stdc++.h>
 
using namespace std;
 
typedef long long ll;
typedef long double ld;
 
typedef vector<int> vi;
typedef vector<ll> vll;
 
typedef vector<vi> vvi;
typedef vector<vll> vvll;
 
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
 
typedef vector<pii> vpii;
typedef vector<pll> vpll;
 
typedef vector<vpii> vvpii;
typedef vector<vpll> vvpll;
 
#define pb push_back
#define mp make_pair
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)(x).size()
#define fi first
#define se second
 
template<class T> bool ckmin(T &a, const T &b) {return a > b ? a = b, 1 : 0;}
template<class T> bool ckmax(T &a, const T &b) {return a < b ? a = b, 1 : 0;}
 
namespace debug {
    void __print(int x) {cerr << x;}
    void __print(long long x) {cerr << x;}
    void __print(double x) {cerr << x;}
    void __print(long double x) {cerr << x;}
    void __print(char x) {cerr << '\'' << x << '\'';}
    void __print(const string &x) {cerr << '\"' << x << '\"';}
    void __print(const char *x) {cerr << '\"' << x << '\"';}
    void __print(bool x) {cerr << (x ? "true" : "false");}
 
    template<typename T, typename V>
    void __print(const pair<T, V> &x) {cerr << '{'; __print(x.first); cerr << ','; __print(x.second); cerr << '}';}
    template<typename T>
    void __print(const T &x) {int f = 0; cerr << '{'; for(auto z : x) cerr << (f++ ? "," : ""), __print(z); cerr << "}";}
    void _print() {cerr << "]\n";}
    template <typename T, typename... V>
    void _print(T t, V... v) {__print(t); if(sizeof...(v)) cerr << ", "; _print(v...);}
 
#ifdef DEBUG
#define dbg(x...) cerr << "\e[91m" << "LINE(" << __LINE__ << ") -> " << "[" << #x << "] = ["; _print(x); cerr << "\033[0m";
#else
#define dbg(x...)
#endif
}
 
using namespace debug;
 
const char nl = '\n';
 
mt19937 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

const ll INF = 1e18 + 12;
 
void solve() {
    int n, m;
    cin >> n >> m;

    vvll mat(n, vll(m));

    for(int i = 0; i < n; ++i) {
        for(int j = 0; j < m; ++j) {
            cin >> mat[i][j];
        }
    }

    vvll dp(n, vll(m, INF));

    dp[0][0] = mat[0][0];

    for(int i = 1; i < m; ++i) {
        ckmin(dp[0][i], dp[0][i - 1] + mat[0][i]);
    }

    for(int i = 1; i < n; ++i) {
        for(int j = 0; j < m; ++j) {
            ckmin(dp[i][j], dp[i - 1][j] + mat[i][j]);

            if(j - 1 >= 0) {
                ckmin(dp[i][j], dp[i][j - 1] + mat[i][j]);
            }
        }
    }

    vvll dp2(n, vll(m, INF));

    dp2[n - 1][m - 1] = mat[n - 1][m - 1];

    for(int i = m - 2; i >= 0; --i) {
        ckmin(dp2[n - 1][i], dp2[n - 1][i + 1] + mat[n - 1][i]);
    }

    for(int i = n - 2; i >= 0; --i) {
        for(int j = m - 1; j >= 0; --j) {
            ckmin(dp2[i][j], dp2[i + 1][j] + mat[i][j]);

            if(j + 1 < m) {
                ckmin(dp2[i][j], dp2[i][j + 1] + mat[i][j]);
            }
        }
    }

    vvll calc(n, vll(m));

    for(int i = 0; i < n; ++i) {
        for(int j = 0; j < m; ++j) {
            calc[i][j] = dp[i][j] + dp2[i][j] - mat[i][j];
        }
    }

    vvll levoDiag(n, vll(m, INF));

    for(int i = n - 1; i >= 0; --i) {
        for(int j = 0; j < m; ++j) {
            ckmin(levoDiag[i][j], calc[i][j]);

            if(j - 1 >= 0) {
                ckmin(levoDiag[i][j], levoDiag[i][j - 1]);
            }

            if(i + 1 < n) {
                ckmin(levoDiag[i][j], levoDiag[i + 1][j]);
            }
        }
    }

    vvll desnoDiag(n, vll(m, INF));

    for(int i = 0; i < n; ++i) {
        for(int j = m - 1; j >= 0; --j) {
            ckmin(desnoDiag[i][j], calc[i][j]);

            if(j + 1 < m) {
                ckmin(desnoDiag[i][j], desnoDiag[i][j + 1]);
            }

            if(i - 1 >= 0) {
                ckmin(desnoDiag[i][j], desnoDiag[i - 1][j]);
            }
        }
    }

    int q;
    cin >> q;
    while(q--) {
        int x, y;
        cin >> x >> y;
        --x, --y;

        auto check = [&](int a, int b) {
            return (a >= 0 && a < n) && (b >= 0 && b < m);
        };

        ll ans = INF;

        if(check(x - 1, y + 1)) {
            ckmin(ans, desnoDiag[x - 1][y + 1]);
        }

        if(check(x + 1, y - 1)) {
            ckmin(ans, levoDiag[x + 1][y - 1]);
        }

        cout << ans << nl;
    }
}
 
int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
 
    int testCases = 1;
    // cin >> testCases;
    while(testCases--)
        solve();
}